   00001                                ************************************************************************
   00002                                *MI03                      MANAGEMENT INFORMATION                      *
   00003                                *    DEVICE ID: HH-65A                 HID:       XX.XX-01             *
   00004                                *    FILENAME:  CM_.A61                LANGUAGE:  ASSEMBLY             *
   00005                                *    LOAD MODUL:                       SYSTEM:    RN                   *
   00006                                *    COMPILER:                         ASSEMBLER: ASM V2.1A            *
   00007                                *    TRNR CPU:                         CPU TYPE:  SEL 32/77            *
   00008                                *    ITRTN RATE:                       MODE:                           *
   00009                                *    LINK EDITR:                                                       *
   00010                                *                                                                      *
   00011                                ************************************************************************
   00012                                *PU02                             PURPOSE                              *
   00013                                *                                                                      *
   00014                                ************************************************************************
   00015                                *TI02                      TECHNICAL INFORMATION                       *
   00016                                *    *KEYWORD* ENTP CM.                                                *
   00017                                *                                                                      *
   00018                                ************************************************************************
   00019                                *PA02                        PROGRAM ATTRIBUTES                        *
   00020                                *    LOGICAL RECORDS:            489   GENERAL COMMENTS:            74 *
   00021                                *    FORTRAN LINES:                0   NON-FORTRAN LINES:          489 *
   00022                                *    EXECUTABLE FTN STMTS:         0   NON-EXEC FORTRAN STMTS:       0 *
   00023                                *                                                                      *
   00024                                ************************************************************************
   00025                                *SU01                         SUBPROGRAM USAGE                         *
   00026                                *      NAME       NAME       NAME         NAME       NAME       NAME   *
   00027                                *    TCM        TCMX       TI.          TI.SEC     TI.STRT             *
   00028                                *                                                                      *
   00029                                ************************************************************************
   00030                                *CH02                          CHANGE HISTORY                          *
   00031                                *    REV   DATE        SOFTWARE ANALYST               EMPLOYER         *
   00032                                *                               DESCRIPTION OF CHANGE                  *
   00033                                *    01  18JUL95   JOHN RUCKSTUHL             NAWCTSD CODE 493         *
   00034                                *              INITIAL HEADER INSTALLATION                             *
   00035                                *                                                                      *
   00036                                ************************************************************************
   00037                                *
   00038                                      PROGRAM   CM.
   00039                                *
   00040                                ********* REV 1 - 11/01/84 - BC - ADD CYCLE TIME LOGIC
   00041                                ********* REV 2 - 11/10/84 - LA - ADD INTER-CPU COMMUNICATIONS
   00042                                **********************************************************************
   00043                                *                                                                    *
   00044                                *     CM IS THE CMS SYSTEM MODULE SCHEDULER; IT RUNS UNDER           *
   00045                                *     CONTROL OF CPU TASK SC/,CM IS BIASED FOR IPU OPERATION.        *
   00046                                *                                                                    *
   00047                                *    SMCD1KEY          CDU #1 SCRATCHPAD SERVICE        5HZ          *
   00048                                *    SMCD2KEY          CDU #2 SCRATCHPAD SERVICE        5HZ          *
   00049                                *    SMCD1DSP          CDU #1 DISPLAY SERVICE           5HZ          *
   00050                                *    SMCD2DSP          CDU #2 DISPLAY SERVICE           5HZ          *
   00051                                *    SMRNC1PG          CDU #1 PAGE DECODER              5HZ          *
   00052                                *    SMRNC2PG          CDU #2 PAGE DECODER              5HZ          *
   00053                                *                                                                    *
   00054                                *     IT SOULD BE NOTED THAT:
   00055                                *         THE MODULE TIMER USES THE SAME VARIABLES AS THE
   00056                                *         SM MODULE TIMER.  THEY CANNOT BE RUN AT THE SAME TIME!!!!!!!
   00057                                *
   00058                                *
   00059                                **********************************************************************
   00060                                *
   00061                                *
   00062                                *     EQUATE SECTION
   00063                                *
   00064   P00000                                M.EQUS
                                                 ENDM
   00065   P00000                                M.DQE.
                                                 ENDM
   00066    0001F                       ABBIT    EQU       31
   00067    00010                       MASK     EQU       4W              CALL TBLE. ENTRY MASK OFFSET
   00068    00000                       NAME     EQU       0               START   POSITION OF CALL BLOCK
   00069    00014                       STATUS   EQU       5W              STATUS OFFSET INTO CALL TABLE ENTRY
   00070    00018                       SHOW     EQU       6W              SHOW ITS RUNNING COUNTER
   00071    00001                       NRMBIT   EQU       1               NORMAL PROCESS BIT
   00072    00002                       TRMBIT   EQU       2               TERMINATION PROCESS BIT
   00073    00003                       DRDBIT   EQU       3               DRED MODE BIT
   00074    00077                       TIMER    EQU       X'77'           INTERVAL TIMER DEVICE CODE
   00075    00041                       READTMR  EQU       X'41'           READ FUNCTION VALUE
   00076                                *
   00077                                ***************************************************************
   00078                                *
   00079                                *     EXTERNAL REFERENCE SECTION
   00080                                *
   00081                                         DEF       CM.
   00082                                *
   00083                                         EXT       TCM             MODULE TABLE START ADDRESS
   00084                                         EXT       TCMX            MODULE TABLE END ADDRESS
   00085                                         EXT       TI.             TIMER ROUTINE
   00086                                         EXT       TI.STRT         TIMER START
   00087                                         EXT       TI.SEC          CYCLE TIMER
   00088                                *
   00089                                ****************************************************************
   00090                                *
   00091                                *        DATAPOOL REFERENCE SECTION
   00092                                *
   00093                                DATAPOOL COMMON    FRMASK          FRAME SEQUENCE BIT WORD
   00094                                DATAPOOL COMMON    FSCEXEC         EXECUTIVE FLAGS
   00095                                DATAPOOL COMMON    IRNNAME         ABORTED ROUTINE NAME
   00096                                DATAPOOL COMMON    IRNABCDE        ABORT CODE
   00097                                DATAPOOL COMMON    FSPCM4          TASK ACTIVE COUNTER
   00098                                DATAPOOL COMMON    FSMACTIV        SM ACTIVE FLAG
   00099                                DATAPOOL COMMON    ISMMODNM        MODULE NAME ON TIMING PAGE
   00100                                DATAPOOL COMMON    ISMTIM          MODULE TIMER FRAME STORAGE
   00101                                DATAPOOL COMMON    ISC30HZ         FRAME COUNTER
   00102                                DATAPOOL COMMON    ITIMINDX        TIMER INDEX
   00103                                DATAPOOL COMMON    FRMIPU          CYCLE TIMER
   00104                                DATAPOOL COMMON    ITIMVNTS        CYCLE TIMER
   00105                                DATAPOOL COMMON    IPUBOVRN        CYCLE TIMER
   00106                                *
   00107                                DATAPOOL COMMON    TSFID           INTER-CPU FLAGS
   00108                                *
   00109                                ****************************************************************
   00110                                *     PATH CONTROL
   00111                                *****************************************************************
   00112                                *
   00113                                         LIST NOMAC NOLREP NODATA
   00114                                *
   00115   P00000  434D4944                      DATAW     C'CMID'         SM/ DUMP LOCATOR
   00116                                *
   00117   P00004                       CM.      EQU       $               TASK ENTRY POINT
   00118                                *
   00119                                *
   00120   P00004                                TC$PATH   CM.NRML,CM.TERM,ISCMFLG
   00121                                *
   00122   P00018                       CM.INIT  EQU       $
   00123                                *
   00124                                *
   00125   P00018  F88002F9   P002F8             BL        M.FBUFF         RESET BUFFER
   00126   P0001C  AE00040A   P00408             LD        R4,BLANK        INIT. FIELD BUFFER
   00127   P00020  D60003DA   P003D8             STD       R4,FLD1         FUNCTION FIELD
   00128   P00024  D60003E2   P003E0             STD       R4,FLD2         NAME FIELD
   00129   P00028  D60003EA   P003E8             STD       R4,FLD3         DATA FIELD
   00130                                *
   00131                                *
   00132   P0002C                                M.SUAR    CM.ABRT         SET UP ABORT RECEIVER
   00133                                *
   00134   P00034                                M.RCVR    M.COLL          SET UP MESSAGE RECEIVER
   00135                                *
   00136   P0003C  F88002F9   P002F8             BL        M.FBUFF         RESET BUFFER
   00137                                *
   00138                                *
   00139   P00040  EC0002A1   P002A0             BU        CM.SUSP         SUSPEND TASK
   00140                                *
   00141                                *************************************************************
   00142                                *     NORMAL PROCESSING POINT
   00143                                *************************************************************
   00144                                *
   00145   P00044                       CM.NRML  EQU       $
   00146                                *
   00147                                ********** FIRST SEE IF OPERATOR INTERACTION *****************
   00148                                *
   00149   P00044  9A080001   A00001             SBM       12,IPUBOVRN     SET OVERRUN INDICATOR
   00150                                *
   00151   P00048  CA0000FF                      LI        R4,X'FF'        SM ACTIVE FLAG
   00152   P0004C  D6080000   A00000             STB       R4,FSMACTIV     SAVE
   00153                                *
   00154   P00050  AC000000   A00000             LW        R0,ITIMINDX     GET TIMER INDEX
   00155   P00054  C8050011                      CI        R0,17           17=START OF CM/ TO END OF CM/
   00156   P00058  F2000061   P00060             BNE       $+2W            SKIP IF NOT 17
   00157   P0005C  F8800001   X00000             BL        TI.STRT         START TIMER
   00158                                *
   00159   P00060  AE000372   P00370             LD        R4,MESSAGE      LOOK FOR INPUT CHARACTERS
   00160   P00064  9200040A   P00408             CAMD      R4,BLANK        BLANKS MEAN
   00161   P00068  EE000071   P00070             BEQ       CM.CTP          NO MESSAGE,PROCESS AS IS
   00162   P0006C  F8800115   P00114             BL        CM.MODM         INTERRPRET OPERATOR INPUT
   00163                                *
   00164                                *     **CALL MODULES FROM CALL PROCESS TABLE
   00165                                *     ****TCM = CALL TABLE START
   00166                                *     ****TCMX = CALL TABLE END
   00167                                *     ****CM.CUR = CURRENT MODULE ADDRESS
   00168                                *
   00169   P00070                       CM.CTP   EQU       $
   00170   P00070                                CT$PROCT  TCM,TCMX,CM.CUR,MODSTTIM
           P000D6      0002
           P000EA      0002
           P0010A      0002
   00171   P00110  EC0002A1   P002A0             BU        CM.SUSP         SUSPEND TASK
   00172                                *
   00173                                *************************************************************:
   00174                                *       COLLECT OPERATOR MESSAGE
   00175                                **************************************************************
   00176                                *
   00177                                *
   00178   P00114                       CM.MODM  EQU       $               COLLECT MESSAGE AND INTERPRET
   00179                                *
   00180   P00114  DC000420   P00420             STF       R0,SMRSVE       SAVE SYSTEM REGISTERS
   00181                                *
   00182   P00118  0C90                          ZR        R1              INIT. FIELD COUNT
   00183   P0011A      0ED0                      ZR        R5               "    CHARACTER COUNT
   00184   P0011C  35800370   P00370             LA        R3,MESSAGE      INDEX MESSAGE BUFFER
   00185   P00120  350003D8   P003D8             LA        R2,FLD1         INDEX FIELD STOR GAGE
   00186   P00124  2F20                          TRR       R2,R6           SAVE FIELD
   00187   P00126                       CM.CHAR  EQU       $
   00188   P00128  AE680000    00000             LB        R4,0,X3         INPUT DATA CHARACTER
   00189   P0012C  CA050020                      CI        R4,G' '         BLANK ?
   00190   P00130  F2000155   P00154             BNE       CM.NCHAR        NO GET NEXT CHAR.
   00191   P00134  C8810001                      ADI       R1,1            ITS A BLANK INCR. FIELD COUNT
   00192   P00138  C8850002                      CI        R1,2            MORE THAN THREE?
   00193   P0013C  ED000171   P00170             BGT       CM.A            YES,MESSAGE COMPLETE
   00194   P00140  C9810001                      ADI       R3,1            NO INCFREMENT MESSAGE INDEX
   00195   P00144  2D60                          TRR       R6,R2           RESTORE FIELD BASE ADDRESS TO INDEX
   00196   P00148  C9010008                      ADI       R2,2W           NEXT FIELD
   00197   P0014C  2F20                          TRR       R2,R6           SAVE FIELD BASE FOR NEXT PASS
   00198   P0014E      0ED0                      ZR        R5              CLEAR CHAR./FIELD COUNT
   00199   P00150  EC000127   P00126             BU        CM.CHAR         GET FIRST CHAR. NEXT FIELD
   00200   P00154                       CM.NCHAR EQU       $
   00201   P00154  CA810001                      ADI       R5,1            INCR. CHAR.S PER FIELD
   00202   P00158  CA850008                      CI        R5,8            CHAR.CNT.LIMIT IS 8(0-7)
   00203   P0015C  ED000261   P00260             BGT       SMT.ERR         PROCESS INPUT ERROR
   00204   P00160  D6480000    00000             STB       R4,0,X2         STORE CHARACTER
   00205   P00164  C9810001                      ADI       R3,1            INCR. MESSAGE INDEX
   00206   P00168  C9010001                      ADI       R2,1            INCR. STORE INDEX
   00207   P0016C  EC000127   P00126             BU        CM.CHAR         GET NEXT CHARACTER
   00208                                *
   00209                                *         ANALIZE MESSAGE
   00210                                *
   00211   P00170                       CM.A     EQU       $
   00212   P00170  AE0003D8   P003D8             LW        R4,FLD1         CONTENTS FIELD ONE
   00213   P00174  348003F0   P003F0             LA        R1,FTABLE       INDEX FUNCTION TABLE ADDRESS
   00214   P00178  36800400   P00400             LA        R5,FTABLEX      FUNCTION TABLE END ADDRESS
   00215   P0017C  F8080313   P00313             ZMB       PRINDEX         ZERO PROCESS INDEX
   00216   P00180  AF200000    00000    CM.A1    LW        R6,0,X1         LOAD FUNCTION FROM TABLE
   00217   P00184  0F40                          EOR       R4,R6           COMPARE INPUT TO FUNCTION TABLE
   00218   P00188  EE0001A1   P001A0             BZ        CM.MTCH         FOUND IT,FUNCTION MATCHED
   00219   P0018C  C8810004                      ADI       R1,1W           UPDATE TABLE INDEX
   00220   P00190  1290                          CAR       R1,R5           COMPARE TO TABLE END
   00221   P00194  ED800261   P00260             BLT       SMT.ERR         DONE,BCAUSE WRONG INPUT
   00222   P00198  A3880313   P00313             ABM       7,PRINDEX       INCR. PROCESS INDEX
   00223   P0019C  EC000181   P00180             BU        CM.A1           GET NEXT
   00224                                *
   00225                                *******  FUNCTION MATCHED, NOW COMPARE ROUTINE NAMES
   00226                                *
   00227   P001A0                       CM.MTCH  EQU       $
   00228                                *
   00229                                *        LW        R4,FLD1         ETIM DOESN'T NEED
   00230                                *        EOMW      R4,ETIM         THE MODULE NAME
   00231                                *        BZ        CM.MTCH1        TO FUNCTION !
   00232                                *
   00233   P001A0  34800070   Y00070             LA        R1,TCM          TABLE START
   00234   P001A4  36800074   Y00074             LA        R5,TCMX         TABLE END
   00235   P001A8                       CM.A2    EQU       $
   00236   P001A8  AF200002    00000             LD        R6,0,X1         LOAD NAME
   00237   P001AC  8F0003E2   P003E0             EOMD      R6,FLD2         COMPARE INPUT NAME TO TABLE
   00238   P001B0  EE0001C5   P001C4             BZ        CM.MTCH1        THEY MATCHED
   00239   P001B4  C8810020                      ADI       R1,8W           INDEX NEXT ENTRY
   00240   P001B8  1290                          CAR       R1,R5           COMPARE TO TABLE END
   00241   P001BC  ED800261   P00260             BLT       SMT.ERR         NOT CORRECT ROUTINE NAME
   00242   P001C0  EC0001A9   P001A8             BU        CM.A2           GET NEXT FUNCTION
   00243                                *
   00244                                *     BOTH FUNCTION AND NAME ARE GOOD
   00245                                *
   00246                                *     THE JUMP TABLE ORDER MUST MATCH THE ORDER OF THE FUNCTION
   00247                                *     TABLE (FTABLE), FOR INDEXING TO THE CORRECT ROUTINE.
   00248                                *
   00249                                *
   00250   P001C4                       CM.MTCH1 EQU       $
   00251   P001C4  AD080313   P00313             LB        R2,PRINDEX      GET PROCESS INDEX
   00252   P001C8  7142                          SLL       R2,2            MAKE WORD ADDRESS
   00253   P001CC  EC4001D1   P001D0             BU        $+1W,X2         BRANCH TO PERTINENT PROCESS POINT
   00254                                *
   00255   P001D0  EC0001E5   P001E4             BU        CM.STAR         START A MODULE
   00256                                *
   00257   P001D4  EC0001ED   P001EC             BU        CM.STOP         STOP A MODULE
   00258                                *
   00259   P001D8  EC0001F5   P001F4             BU        CM.STIM         START TIMING A MODULE
   00260                                *
   00261   P001DC  EC00020D   P0020C             BU        CM.ETIM         END A MODULE TIMING
   00262                                *
   00263   P001E0  EC00023D   P0023C             BU        CM.MASK         INSERT NEW MASK
   00264                                *
   00265   P001E4                       CM.STAR  EQU       $
   00266   P001E4  9FA80017    00017             ZBM       31,STATUS,X1    CLEAR THE "STOP" BIT
   00267   P001E8  EC000245   P00244             BU        CM.CLFLD        NORMAL PROCESSING
   00268                                *
   00269   P001EC                       CM.STOP  EQU       $
   00270   P001EC  9BA80017    00017             SBM       31,STATUS,X1    SET THE STOP BIT
   00271   P001F0  EC000245   P00244             BU        CM.CLFLD
   00272                                *
   00273   P001F4                       CM.STIM  EQU       $
   00274   P001F4  9A880000   A00000             SBM       05,FSCEXEC      SET GENERAL TIMING FLAG
   00275   P001F8  EC800261   P00260             BS        SMT.ERR         IF NOT SET
   00276   P001FC  9B280017    00017             SBM       30,STATUS,X1    SET THE MODULE TIMING FLAG
   00277   P00200  AF200002    00000             LD        R6,NAME,X1      SEND NAME TO GRAPHICS
   00278   P00204  D7000002   A00000             STD       R6,ISMMODNM     THROUGH DATAPOOL
   00279   P00208  EC000245   P00244             BU        CM.CLFLD        CLEAR MESSAGE FIELD
   00280                                *
   00281   P0020C                       CM.ETIM  EQU       $
   00282   P0020C  A7280017    00017             TBM       30,STATUS,X1    RESET MODULE TIMING
   00283   P00210  F0800261   P00260             BNS       SMT.ERR         UNLESS NOT SET
   00284   P00214  9F280017    00017             ZBM       30,STATUS,X1    IF SET CLEAR MODULE
   00285   P00218  9E880000   A00000             ZBM       05,FSCEXEC      AND GENERAL TIMING BITS
   00286   P0021C  9EA80017    00017             ZBM       29,STATUS,X1    CLEAR PAGE NAME FLAG
   00287                                *        CLEAR SCREEN              *
   00288   P00220  C880FF88                      LI        R1,-30W         NUMBER OF FRAMES
   00289   P00224  0ED0                          ZR        R5              CLEAR WITH ZEROS
   00290   P00226                       CM.CLRSC EQU       $
   00291   P00228  D6A00078   A00078             STW       R5,ISMTIM+30W,X1                            CLEAR
   00292   P0022C  F4C00227   P00226             BIW       R1,CM.CLRSC     GET NEXT OF 30
   00293                                *        REMOVE MODULE NAME FROM SCREEN                        *
   00294   P00230  AE00040A   P00408             LD        R4,BLANK        BLANK THE NAME
   00295   P00234  D6000002   A00000             STD       R4,ISMMODNM
   00296                                *
   00297   P00238  EC000245   P00244             BU        CM.CLFLD        CLEAR MESSAGE FIELD
   00298                                *
   00299   P0023C                       CM.MASK  EQU       $
   00300   P0023C  AE0003EA   P003E8             LD        R4,FLD3         INPUT MASK VALUE
   00301   P00240  D6200012    00010             STD       R4,MASK,X1      SAVE IT IN MODULE TBLE. ENTRY
   00302                                *
   00303   P00244                       CM.CLFLD EQU       $
   00304   P00244  AD00040A   P00408             LD        R2,BLANK        RESET MESSAGE FIELD TO BLANKS
   00305   P00248  D50003DA   P003D8             STD       R2,FLD1         FUNCTION FIELD
   00306   P0024C  D50003E2   P003E0             STD       R2,FLD2         ROUTINE NAME FIELD
   00307   P00250  D50003EA   P003E8             STD       R2,FLD3         DATA FIELD
   00308                                *
   00309   P00254  F88002F9   P002F8             BL        M.FBUFF         BLANK OVER BUFFER
   00310                                *
   00311   P00258  CC000420   P00420             LF        R0,SMRSVE       RESTORE REGISTERS
   00312   P0025C  2800                          TRSW      R0              RETUCM TO MAIN CM.
   00313                                *
   00314   P00260                                BOUND     1W              FORCE WORD BOUNDARY AFTER TRSW
   00315                                *
   00316   P00260                       SMT.ERR  EQU       $
   00317   P00260  F88002F9   P002F8             BL        M.FBUFF         RESET INPUT BUFFER
   00318   P00264  9B880000   A00000             SBM       07,FSCEXEC      SET OPERATOR INPUT ERROR
   00319   P00268  EC0002A1   P002A0             BU        CM.SUSP         SUSPEND AFTER ERROR
   00320                                *
   00321                                ***************************************************************
   00322                                *
   00323                                *      MESSAGE RECEIVER INTERRUPT AND EXIT POINT              *
   00324                                *
   00325                                ***************************************************************
   00326                                *
   00327                                         LIST      NONG
   00328   P0026C                                BOUND     1W              FORCE WORD BOUNDARY
   00329   P0026C                       M.COLL   EQU       $
   00330                                *
   00331   P0026C                                M.GMSGP   RECBLK          MESSAGE INTERRUPT POINT
   00332                                *
   00333                                *
   00334   P00274                                M.XMSGR   MEXIT           MESSAGE INT. EXIT SERVICE
   00335                                *
   00336   P0027C  EC0002A1   P002A0             BU        CM.SUSP         SUSPEND
   00337                                *
   00338                                *
   00339                                ************************************************************
   00340                                *     CM ABORT PROCESSOR
   00341                                ************************************************************
   00342                                *
   00343                                *       ABORT HANDLER SET UP BY MPX,M.SUAR SERVICE AND
   00344                                *   REACHED WHEN SYSTEM ABORT OCCURS.
   00345                                *
   00346   P00280                       CM.ABRT  EQU       $
   00347                                *
   00348                                *        LW        R2,C.CURR       CURRENT DQE ADDRESS
   00349                                *        LW        R5,DQE.ABC,X2   COLLECT ABORT CODE FOR OUTPUT
   00350                                *        STW       R5,IRNABCDE     OUTPUT BUFFER CODE WORDS
   00351                                *        LW        R5,DQE.ABC+1W,X2
   00352                                *        STW       R5,IRNABCDE+1W
   00353                                *        LW        R5,DQE.ABC+2W,X2
   00354                                *        STW       R5,IRNABCDE+2W
   00355                                *
   00356                                *
   00357   P00280  AD800338   P00338             LW        R3,CM.CUR       CURRENT SM/ CALL PROCESS ADDRESS
   00358                                *
   00359   P00284  AE600002    00000             LD        R4,0W,X3        NAME,OFFENDING ROUTINE
   00360   P00288  D6000002   A00000             STD       R4,IRNNAME      TO OUTPUT BUFFER
   00361                                *
   00362   P0028C  9BE80017    00017             SBM       ABBIT,STATUS,X3 SET ABORT BIT FOR THIS ROUTINE
   00363                                *
   00364   P00290  9B080000   A00000             SBM       06,FSCEXEC      SIGNAL ABORT MESSAGE
   00365                                *
   00366   P00294  EC000005   P00004             BU        CM.             SUSPEND SM/
   00367                                *
   00368                                *************************************************************
   00369                                *     TERMINATION POINT
   00370                                *************************************************************
   00371                                *
   00372   P00298                       CM.TERM  EQU       $
   00373                                *
   00374   P00298  9C880312   P00312             ZBM       NRMBIT,ISCMFLG  SO SM/ WILL REINITIALIZE
   00375   P0029C                                M.EXIT
   00376                                *
   00377                                **************************************************************
   00378                                **********  TASK SUSPENSION   ********************************
   00379                                *
   00380   P002A0                       CM.SUSP  EQU       $
   00381                                *
   00382   P002A0  AC000000   A00000             LW        R0,ITIMINDX     GET TIMER INDEX
   00383   P002A4  C8050066                      CI        R0,102          CYCLE TIMER?
   00384   P002A8  EE0002C5   P002C4             BEQ       CM.CT           YES
   00385   P002AC  C8050010                      CI        R0,16           16=TOP TO END OF CM/
   00386   P002B0  EE0002BD   P002BC             BEQ       $+3W            TIME IF = 16
   00387   P002B4  C8050011                      CI        R0,17           17=JUST CM/
   00388   P002B8  F20002C1   P002C0             BNE       $+2W            SKIP IF NOT 17 EITHER
   00389   P002BC  F8800001   X00000             BL        TI.              CALCULATE & STORE FRAME TIMER
   00390   P002C0  EC0002D5   P002D4             BU        CM.NCT          SKIP CYCLE TIMING
   00391                                *
   00392   P002C4                       CM.CT    EQU       $               CYCLE TIMER
   00393                                *
   00394   P002C4  F8800001   X00000             BL        TI.SEC          CALL CYCLE TIMER
   00395   P002C8  D4800000   A00000             STW       R1,FRMIPU       STORE TIME CONTRIB.
   00396   P002CC  A3880003   A00003             ABM       31,ITIMVNTS     BUMP EVENTS COUNTER
   00397   P002D0  9E080001   A00001             ZBM       12,IPUBOVRN     RESET OVERRUN INDICATOR
   00398                                *
   00399   P002D4                       CM.NCT   EQU       $
   00400                                *
   00401   P002D4  F8080000   A00000             ZMB       FSMACTIV        CLEAR SM ACTIVE FLAG
   00402                                *
   00403   P002D8                                M.SUSP    CMTASK,CMTASK
   00404                                *
   00405   P002E4  A5080000   A00000             TBM       TRMBIT,TSFID    TERMINATION BIT?
   00406   P002E8  EC800299   P00298             BS        CM.TERM         YES, EXIT
   00407                                *
   00408   P002EC  A5880000   A00000             TBM       DRDBIT,TSFID    DRED MODE BIT?
   00409   P002F0  EC800299   P00298             BS        CM.TERM         YES, EXIT
   00410                                *
   00411   P002F4  EC000005   P00004             BU        CM.             RETURN WHEN RESUMED
   00412                                *
   00413                                *************************************************************
   00414                                ********** RESET BUFFER SUBROUTINE **************************
   00415                                *
   00416   P002F8                       M.FBUFF  EQU       $
   00417   P002F8  34800370   P00370             LA        R1,MESSAGE      BUFFER START ADDRESS
   00418   P002FC  C900FFB8                      LI        R2,-72          BYTE COUNT
   00419   P00300  AE080447   P00447             LB        R4,=C' '        BLANK
   00420   P00304  D6280000    00000    M.BLANK  STB       R4,0B,X1        STORE BLANK
   00421   P00308  C8810001                      ADI       R1,1            BUMP INDEX
   00422   P0030C  F5000305   P00304             BIB       R2,M.BLANK      KEEP ON BLANKING
   00423   P00310  2800                          TRSW      R0              RETUCM
   00424                                *
   00425                                **************************************************************
   00426                                *     LOCAL DATA SECTION
   00427                                **************************************************************
   00428                                *
   00429   P00312      00               ISCMFLG  REZ       1B              CM PATH SELECTION FLAG
   00430   P00313        00             PRINDEX  REZ       1B              PRINT INDEX
   00431                                *
   00432   P00314                                BOUND     1W
   00433   P00314  00000280   P00280    ABRECADR ACW       CM.ABRT         ABORT SECTION ADDRESS
   00434                                *
   00435   P00318                                BOUND     1D
   00436   P00318  00000000             CMTASK   DATAD     0               SUSPND OWN TASK
           P0031C  00000000
   00437   P00320  494E4552             CM.ERRM  DATAD     C'INERR'        INPUT ERROR MESSAGE
           P00324  52202020
   00438   P00328  494E2F46             INFADDR  DATAD     C'IN/FLT'
           P0032C  4C542020
   00439   P00330  00000000             COUNT    DATAW     0
   00440   P00338  00000000             CM.CUR   REZ       1D              CURRENT EXECUTING MODULE ADDRESS
           P0033C  00000000
   00441   P00340  44415441             DPLNAME  DATAD     C'DATAPOOL'
           P00344  504F4F4C
   00442   P00348  474C4F42             GLBNAME  DATAD     C'GLOBAL01'
           P0034C  414C3031
   00443   P00350                                BOUND     1D
   00444   P00350                                RES       1W
   00445   P00354                       TSKENTRY EQU       $
   00446   P00354                       TSKNUM   RES       1W
   00447   P00358  494E2F46             TASK     DATAD     C'IN/FLT'
           P0035C  4C542020
   00448   P00360  00000000             OWNER    DATAD     0
           P00364  00000000
   00449   P00368                                RES       2W
   00450                                *
   00451                                ********* MESSAGE BUFFER *******************************
   00452   P00370  00000000             MESSAGE  REZ       72B             MESSAGE RECEIVE BUFFER
           P00374  00000000
           P00378  00000000
           P0037C  00000000
           P00380  00000000
           P00384  00000000
           P00388  00000000
           P0038C  00000000
           P00390  00000000
           P00394  00000000
           P00398  00000000
           P0039C  00000000
           P003A0  00000000
           P003A4  00000000
           P003A8  00000000
           P003AC  00000000
           P003B0  00000000
           P003B4  00000000
   00453                                *
   00454                                *
   00455   P003B8                                BOUND     1W              FORCE WORD BOUNDARY
   00456   P003B8                       RECBLK   EQU       $
   00457   P003B8  00000370   P00370             GEN       8/0,24/W(MESSAGE)
   00458   P003BC  00480000                      GEN       16/72,16/0      MESS. MAX./ACTUALL
   00459   P003C0  00000000                      DATAW     0
   00460   P003C4  00000000                      DATAW     0
   00461   P003C8  00000000                      DATAW     0
   00462                                *
   00463   P003CC                       MEXIT    EQU       $
   00464   P003CC  00000000                      REZ       2W              EXIT BUFFER
           P003D0  00000000
   00465                                *
   00466   P003D8                                BOUND     1D              FORCE DOUBLE WORD BOUNDARY
   00467                                *
   00468   P003D8  00000000             FLD1     REZ       2W              MESSAGE FIELD 1   FUNCTION
           P003DC  00000000
   00469   P003E0  00000000             FLD2     REZ       2W                "       "   2   ROUTINE NAME
           P003E4  00000000
   00470   P003E8  00000000             FLD3     REZ       2W                "       "   3   DATA
           P003EC  00000000
   00471                                *
   00472                                *           FUNCTION TABLE
   00473                                *
   00474   P003F0                       FTABLE   EQU       $
   00475   P003F0  53544152                      DATAW     C'STAR'         START FUNCTION
   00476   P003F4  53544F50                      DATAW     C'STOP'         OBVIOUS
   00477   P003F8  5354494D                      DATAW     C'STIM'         START A MODULE TIMING
   00478   P003FC  4554494D             ETIM     DATAW     C'ETIM'         END A MODULE TIMING
   00479   P00400  4D41534B                      DATAW     C'MASK'         CHANGE MASK VALUE FUNCTION
   00480   P00400                       FTABLEX  EQU       $-1W
   00481                                *
   00482   P00408  20202020             BLANK    DATAD     C' '
           P0040C  20202020
   00483                                *
   00484                                *
   00485   P00420  00000000             SMRSVE   REZ       1F              STORE REGISTERS
           P00424  00000000
           P00428  00000000
           P0042C  00000000
           P00430  00000000
           P00434  00000000
           P00438  00000000
           P0043C  00000000
   00486                                *
   00487   P00440  00000000             MODSTTIM DATAW     0               START TIME FOR MODULE TIMING
   00488                                *
           P00444  20202020
   00489   P00448             P00004             END       CM.
*  0000  ERRORS IN CM.
  
  L00000    20202020  *00419
  J000D8    :OFFSET   *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065
  J00001    :OFFSETB  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065
  J00008    :OFFSETD  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                       00065   00065   00065   00065
  J00002    :OFFSETH  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                       00065   00065   00065   00065
  J00004    :OFFSETW  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                      *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065  *00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065   00065   00065   00065   00065   00065   00065   00065   00065
                       00065   00065   00065
   0001F    ABBIT     *00066   00362
  P00408    BLANK     *00482   00126   00160   00294   00304
  P00004    CM.       *00117   00081   00366   00411   00489
  P00170    CM.A      *00211   00193
  P00180    CM.A1     *00216   00223
  P001A8    CM.A2     *00235   00242
  P00280    CM.ABRT   *00346   00132   00433
  P00126    CM.CHAR   *00187   00199   00207
  P00244    CM.CLFLD  *00303   00267   00271   00279   00297
  P00226    CM.CLRSC  *00290   00292
  P002C4    CM.CT     *00392   00384
  P00070    CM.CTP    *00169   00161
  P00338    CM.CUR    *00440   00170   00170   00170   00170   00170   00357
  P0020C    CM.ETIM   *00281   00261
  P0023C    CM.MASK   *00299   00263
  P00114    CM.MODM   *00178   00162
  P001A0    CM.MTCH   *00227   00218
  P001C4    CM.MTCH1  *00250   00238
  P00154    CM.NCHAR  *00200   00190
  P002D4    CM.NCT    *00399   00390
  P00044    CM.NRML   *00145   00120
  P001E4    CM.STAR   *00265   00255
  P001F4    CM.STIM   *00273   00259
  P001EC    CM.STOP   *00269   00257
  P002A0    CM.SUSP   *00380   00139   00171   00319   00336
  P00298    CM.TERM   *00372   00120   00406   00409
  P00318    CMTASK    *00436   00403   00403
   000B0    DQE.CDIR  *00065   00065
   00003    DRDBIT    *00073   00408
  P003D8    FLD1      *00468   00127   00185   00212   00305
  P003E0    FLD2      *00469   00128   00237   00306
  P003E8    FLD3      *00470   00129   00300   00307
  A40000    FRMASK    *00093   00170
  A40000    FRMIPU    *00103   00395
  A40000    FSCEXEC   *00094   00274   00285   00318   00364
  A40000    FSMACTIV  *00098   00152   00401
  P003F0    FTABLE    *00474   00213
  P00400    FTABLEX   *00480   00214
  A40000    IPUBOVRN  *00105   00149   00397
  A40000    IRNNAME   *00095   00360
  A40000    ISC30HZ   *00101   00170
  P00312    ISCMFLG   *00429   00120   00120   00120   00374
  A40000    ISMMODNM  *00099   00170   00278   00295
  A40000    ISMTIM    *00100   00170   00170   00170   00291
  A40000    ITIMINDX  *00102   00154   00382
  A40000    ITIMVNTS  *00104   00396
  P00304    M.BLANK   *00420   00422
  P0026C    M.COLL    *00329   00134
  P002F8    M.FBUFF   *00416   00125   00136   00309   00317
   00010    MASK      *00067   00170   00301
  P00370    MESSAGE   *00452   00159   00184   00417   00457
  P003CC    MEXIT     *00463   00334
  P00440    MODSTTIM  *00487   00170   00170
   00000    NAME      *00068   00170   00277
   00001    NRMBIT    *00071   00120   00120   00374
  P00313    PRINDEX   *00430   00215   00222   00251
   00000    R0        *00064   00154   00155   00170   00170   00170   00170   00170   00180   00311   00312
                       00382   00383   00385   00387   00423
   00001    R1        *00064   00170   00170   00170   00170   00182   00191   00192   00213   00219   00220
                       00233   00239   00240   00288   00292   00395   00417   00421
   00002    R2        *00064   00185   00186   00195   00196   00197   00206   00251   00252   00304   00305
                       00306   00307   00418   00422
   00003    R3        *00064   00170   00170   00170   00184   00194   00205   00357
   00004    R4        *00064   00126   00127   00128   00129   00151   00152   00159   00160   00188   00189
                       00204   00212   00217   00294   00295   00300   00301   00359   00360   00419   00420
   00005    R5        *00064   00183   00198   00201   00202   00214   00220   00234   00240   00289   00291
   00006    R6        *00064   00170   00186   00195   00197   00216   00217   00236   00237   00277   00278
  P003B8    RECBLK    *00456   00331
   00018    SHOW      *00070   00170
  P00420    SMRSVE    *00485   00180   00311
  P00260    SMT.ERR   *00316   00203   00221   00241   00275   00283
   00014    STATUS    *00069   00170   00170   00170   00170   00266   00270   00276   00282   00284   00286
                       00362
  X6C5D8    TCM       *00083   00170   00233
  X6C610    TCMX      *00084   00170   00234
  X6C648    TI.       *00085   00389
  X6C6B8    TI.SEC    *00087   00394
  X6C680    TI.STRT   *00086   00157
   00002    TRMBIT    *00072   00120   00405
  A40000    TSFID     *00107   00405   00408
   00001    X1        *00064   00216   00236   00266   00270   00276   00277   00282   00284   00286   00291
                       00301   00420
   00002    X2        *00064   00204   00253
   00003    X3        *00064   00170   00170   00170   00188   00359   00362
  B6D0C0    CT$PROCT  *00170
